//+------------------------------------------------------------------+
//|                                            PipTimerExpert_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"


#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName = "PipTimerExpert_v1.1";

extern string     Data = " Input Data ";
extern int     MagicNumber    =0;
extern bool    EnablePipTimer =true;
extern bool    UseTicks       =true;
extern double  MinPipProfit   =6;                //in pips
extern double  TakePipTimer   =60;               //in seconds or ticks

datetime TimerStart; 
int      Counter, SlipPage=3;
double   PipProfit, BestPipProfit=0, MaxPipProfit=0;
bool     StartCount=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   //CloseSignal=false;
//----
   return(0);
  }

// ---- Scan Open Trades
int ScanOpenTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
    
   for(int cnt=0; cnt<=total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
      if(OrderSymbol()==Symbol() && OrderType()<=OP_SELL)
      {
      if(MagicNumber > 0) if(OrderMagicNumber() == MagicNumber) numords++;
      if(MagicNumber == 0) numords++;
      }
   }   
   return(numords);
}

void PipTimerExit()
{
  //double _point = MarketInfo(OrderSymbol(),MODE_POINT); 
  //double PipProfit = 0;
   
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);   
   int mode=OrderType();
      
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         if (mode==OP_BUY) 
         PipProfit = MathRound((Bid - OrderOpenPrice())/Point); 
         else 
         if (mode==OP_SELL) 
         PipProfit = MathRound((OrderOpenPrice()-Ask)/Point); 
			
			MaxPipProfit = MathMax(PipProfit,MaxPipProfit);
			//Print("Point=",_point, " Point1=",Point);
			//Print("Profit=", PipProfit," MaxProfit=",MaxPipProfit," BestProfit",BestPipProfit);  
			if (MaxPipProfit >= MinPipProfit)
			{
			   if (!StartCount || ( StartCount && MaxPipProfit > BestPipProfit)) 
			   {
			   BestPipProfit=MaxPipProfit;
			   TimerStart = CurTime(); 
			   Counter = TakePipTimer;
			   StartCount=true;
			   }
			}   
			//else
			if(StartCount)
			{
			
			if(UseTicks) Counter=Counter-1;
			else Counter = TakePipTimer - (CurTime() - TimerStart);
			
			//Print(" TimerStart=",TimeToStr(TimerStart, TIME_DATE|TIME_MINUTES));  
			   if ( Counter <= 0)
			   {
			   Counter=0;
			   StartCount=false; 
			   PipProfit=0; BestPipProfit=0; MaxPipProfit=0; 
			      if(mode==OP_BUY)
			      {
			      OrderClose(OrderTicket(),OrderLots(),Bid,SlipPage,Yellow);
			      break;
			      }
			      else
			      if(mode==OP_SELL)
			      {
			      OrderClose(OrderTicket(),OrderLots(),Ask,SlipPage,Yellow);
			      break;
			      }
            }   			         
         }
      }
   }
}   

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   //Print("Profit=", PipProfit," MaxProfit=",MaxPipProfit," BestProfit",BestPipProfit);  
   sComment = sp;
   sComment = sComment + "Open Positions=" + ScanOpenTrades() + NL;
   sComment = sComment + "Current Profit(pips)= " + DoubleToStr(PipProfit,0) + NL;
   sComment = sComment + "Max Profit(pips)= " + DoubleToStr(MaxPipProfit,0) + NL;
   sComment = sComment + "Exit Counter = " + Counter + NL; 
   sComment = sComment + sp;
  
   Comment(sComment);
}	   
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   
   
   //Print(" Trades=",ScanOpenTrades()," Pips=",PipProfit);
   if(EnablePipTimer && ScanOpenTrades() > 0) {PipTimerExit();ChartComment();}
   
   
          
 return(0);
}//int start
//+------------------------------------------------------------------+





